import java.util.Scanner;
import java.util.Random;
import java.io.File;

public class U4ImmuneAndMS5{
  public static int tellAntallLinjer(String filNavn) throws Exception{
    File fil = new File(filNavn);
    Scanner innleser = new Scanner(fil);
    
    int teller = 0;
    while (innleser.hasNextLine()){
      innleser.nextLine();
      teller +=1;      
    }
    return teller;
  }
  
  public static int[] lesTallFraFil(String filNavn, int antallLinjer) throws Exception{
    int[] innlest = new int[antallLinjer];
    
    File fil = new File(filNavn);
    Scanner innleser = new Scanner(fil);
    String linje;
    int teller = 0;
    while (innleser.hasNextLine()){
      linje = innleser.nextLine();
      innlest[teller] = Integer.parseInt(linje);
      teller +=1;      
    }
    return innlest;
    
  }
  public static int tellLokasjonerInnenfor(int[] msLokasjoner, int[] immunStartpunkter, int[] immunSluttpunkter){
    int antallMsInnenfor=0;
    int msLokasjon, immunStart, immunSlutt;
    for (int msIndeks=0; msIndeks < msLokasjoner.length; msIndeks+=1){
      for (int immunIndeks=0; immunIndeks < immunStartpunkter.length; immunIndeks+=1){
        msLokasjon = msLokasjoner[msIndeks];
        immunStart = immunStartpunkter[immunIndeks];
        immunSlutt = immunSluttpunkter[immunIndeks];
        if (msLokasjon>immunStart && msLokasjon<immunSlutt){
          antallMsInnenfor+= 1;
        }
      }
    }
    return antallMsInnenfor;
  }
  
  static int[] trekkTilfeldigeTall(int antall){
    Random sjanse = new Random();
    int[] tall = new int[antall];
      for (int teller=0; teller < antall; teller+=1){
        tall[teller] = sjanse.nextInt(2000000000); 
      }
    return tall;
  }
  
  static double kalkulerPverdi(int antallMsLokasjoner, int antallEkteMsInnenfor, int[] immunStartpunkter, int[] immunSluttpunkter){        
    int[] tilfeldigeMsLokasjoner;
    int antallTilfeldigeMsInnenfor;
    int antallEkstremeObservasjoner= 0;
    int ANTALLET_REPLIKASJONER= 500;
    for (int replikasjon=0; replikasjon<ANTALLET_REPLIKASJONER; replikasjon+=1){
      tilfeldigeMsLokasjoner = trekkTilfeldigeTall(antallMsLokasjoner);
      antallTilfeldigeMsInnenfor= tellLokasjonerInnenfor(tilfeldigeMsLokasjoner, immunStartpunkter, immunSluttpunkter);
      if (antallTilfeldigeMsInnenfor> antallEkteMsInnenfor){
        antallEkstremeObservasjoner += 1;
      }
    }
    double pVerdi = (antallEkstremeObservasjoner+1.0) / ( ANTALLET_REPLIKASJONER+1.0);
    return pVerdi;
  }
  
  public static void main(String[] args) throws Exception {
    //Tell antall linjer i MS-fil
    String msFn = "ms1.txt";
    int msAntallLinjer = tellAntallLinjer(msFn);
    //System.out.println("Antall MS: " + msAntallLinjer);
    
    //Les inn MS-lokasjoner
    int[] msLokasjoner = lesTallFraFil(msFn, msAntallLinjer);
    //System.out.println("MS-lokasjon 3: " + msLokasjoner[2]);
    
    //Tell antall immun-intervaller
    String immunStartFn = "immunStartpunkt1.txt";
    String immunSluttFn = "immunSluttpunkt1.txt";
    int immunAntallLinjer = tellAntallLinjer(immunStartFn);
    //System.out.println("Antall Immun: " + (immunAntallLinjer));

    //Les inn immun-intervaller
    int[] immunStartpunkter = lesTallFraFil(immunStartFn, immunAntallLinjer);
    int[] immunSluttpunkter = lesTallFraFil(immunSluttFn, immunAntallLinjer);
    //System.out.println("Immun-intervall 2 er fra " + immunStartpunkter[1] + " til " + immunSluttpunkter[1]);
    
    //Tell antall MS-lokasjoner innenfor immun
    int antallMsInnenfor = tellLokasjonerInnenfor(msLokasjoner, immunStartpunkter, immunSluttpunkter);
    //System.out.println(antallMsInnenfor + " av " + msAntallLinjer + " MS-lokasjoner er innenfor aktive immun-regioner");
    
    //Simuler tilfeldige MS-lokasjoner og beregn p-verdi
    double resultat = kalkulerPverdi(msAntallLinjer, antallMsInnenfor, immunStartpunkter, immunSluttpunkter);
    System.out.println("P-verdi for at MS er uventet mye inni immun-regioner:");
    System.out.println( resultat);
  } 
}